namespace de.osci.helper {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.dotcommon;
 
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class StoreOutputStream:OutputStream {

		private static Log log;
		private System.IO.Stream baseStream; // InputStream
		private System.IO.Stream copyStream; // OutputStream
		
		public StoreOutputStream(System.IO.Stream outStream, System.IO.Stream copyStream):base() {
			this.baseStream = outStream;
			this.copyStream = copyStream;
		}

		public void  write(int b) {
			baseStream.WriteByte((System.Byte) b);
			copyStream.WriteByte((System.Byte) b);
//			Console.WriteLine("---------"+b);
//			System.Diagnostics.Debug.WriteLine("---------"+b);
		}
		
		public  override void  Write(System.Byte[] b, int off, int len) {
			baseStream.Write(b, off, len);
			copyStream.Write(b, off, len);
//			Console.WriteLine("******"+MoreSupport.NewString(b,0,len));
//			System.Diagnostics.Debug.WriteLine("******"+MoreSupport.NewString(b,0,len));
		}
		
		public override void  Flush() {
			baseStream.Flush();
			copyStream.Flush();
		}

		public override void  Close() {
			Flush();
		    baseStream.Close();
			copyStream.Close();
		}

		static StoreOutputStream() {
			log = LogFactory.getLog(typeof(StoreOutputStream));
		}
	}
}