namespace de.osci.osci12.common
{
	using System;

	/// <summary> <p>In dieser Klasse sind Konstanten der Bibliothek definiert.</p>
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class Constants
	{

		/// <summary> Hashtable mit den bentigten JCA/JCE-Identifiern
		/// </summary>
		public static System.Collections.Hashtable NET_MAP;
		
		/// <summary> Character-Encoding
		/// </summary>
		public const System.String CHAR_ENCODING = "UTF-8";
		
		/// <summary> Algorithmus fr Zufallszahlenerstellung wird auf SHA1 Pseudo Random Number Generation gestellt
		/// </summary>
		public const System.String SECURE_RANDOM_ALGORITHM_SHA1 = "SHA1PRNG";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA1withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA1 = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA1withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA1_NET = "SHA1";

        /// <summary>Hashtable mit Ablaufdaten der Algorithmen und Schlssellngen
        /// </summary>
        public static System.Collections.Hashtable OUT_DATES = new System.Collections.Hashtable();

        /// <summary>Ablaufdatum fr 1024 Bit RSA-Schlssellnge
        /// </summary>
        public static DateTime OUT_DATE_KEYSIZE_1024 = new DateTime(2008, 7, 1);

        /// <summary>Default-Gltigkeitsdatum fr Algorithmusprfungen
        /// </summary>
        public static DateTime ACTUAL_DATE = new DateTime(2011, 7, 1);

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA256 = "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA256_NET = "SHA256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA512 = "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA512_NET = "SHA512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr RIPEMD160withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160 = "http://www.w3.org/2001/04/xmldsig-more/rsa-ripemd160";

        /// <summary> Fr Abwrtskompatibilitt nach Korrektur der Konstante fr RIPEMD160withRSA (Version 1.5, typo in RFC 4051)
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160_LEGACY = "http://www.w3.org/2001/04/xmldsig-more#rsa-ripemd160";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr RIPEMD160withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET = "RIPEMD160";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withECDSA
        /// </summary>
        public const String SIGNATURE_ALGORITHM_ECDSA_SHA256 = "http://www.w3.org/2001/04/xmldsig-more#ecdsa-sha256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withECDSA, RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_ECDSA_SHA256_NET = "SHA256withECDSA";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withECDSA
        /// </summary>
        public const String SIGNATURE_ALGORITHM_ECDSA_SHA512 = "http://www.w3.org/2001/04/xmldsig-more#ecdsa-sha512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withECDSA, RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_ECDSA_SHA512_NET = "SHA512withECDSA";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr Bas64-encoding
		/// </summary>
		public const System.String BASE64_DECODER = "http://www.w3.org/2000/09/xmldsig#base64 ";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA1
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA1 = "http://www.w3.org/2000/09/xmldsig#sha1";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA256
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA256 = "http://www.w3.org/2001/04/xmlenc#sha256";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA512
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA512 = "http://www.w3.org/2001/04/xmlenc#sha512";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr RIPEMD160
        /// </summary>
        public const System.String DIGEST_ALGORITHM_RIPEMD160 = "http://www.w3.org/2001/04/xmlenc#ripemd160";

		/// <summary> Algorithmus fr symmetrische Verschlsselung Two-Key-Triple-DES (CBC-Mode)
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_TDES_CBC = "http://www.w3.org/2001/04/xmlenc#tripledes-cbc";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung Two-Key-Triple-DES (CBC-Mode), JCA/JCE-Identifier
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_TDES_CBC_JCA_JCE = "DESede/CBC/PKCS5Padding";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-128
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES128 = "http://www.w3.org/2001/04/xmlenc#aes128-cbc";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-192
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES192 = "http://www.w3.org/2001/04/xmlenc#aes192-cbc";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-256
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES256 = "http://www.w3.org/2001/04/xmlenc#aes256-cbc";
		
		/// <summary> Algorithmus fr asymmetrische Verschlsselung RSAES-PKCS1-v1_5
		/// </summary>
		public const System.String ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5 = "http://www.w3.org/2001/04/xmlenc#rsa-1_5";
		
		/// <summary> Algorithmus fr asymmetrische Verschlsselung RSAES-PKCS1-v1_5, JCA/JCE-Identifier
		/// </summary>
		public const System.String ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5_JCA_JCE = "RSA/ECB/PKCS1Padding";
		
		//*********************
		// Signieren
		//  public final static String SIGNATURE_ALGORITHM_RSA_SHA1 = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";
		
		// Hash
		//  public final static String SHA1 = "http://www.w3.org/2000/09/xmldsig#sha1";
		
		//public final static String XMLNS = "xmlns:xenc='http://www.w3.org/2001/04/xmlenc#";
		//public final static String NSPREF ="xenc";
		
		// Asymmetrische Verfahren
		//public final static String RSA15 = "http://www.w3.org/2001/04/xmlenc#rsa-1_5";
		
		// Symmetrische Verfahen
		//public final static String TDES ="http://www.w3.org/2001/04/xmlenc#tripledes-cbc";
		//public final static String AES128 ="http://www.w3.org/2001/04/xmlenc#aes128-cbc";
		//public final static String AES192 ="http://www.w3.org/2001/04/xmlenc#aes192-cbc";
		//public final static String AES256 ="http://www.w3.org/2001/04/xmlenc#aes256-cbc";
		
		// Werte fuer Type
		// Die folgenden Konstanten knnen evtl. in die EncryptedData- oder Signature-Klassen
		//public final static String TYPE_ENCRYPTEDKEY="http://www.w3.org/2001/04/xmlenc#EncryptedKey";
		//public final static String Type_ENCRYPTIONPROPERTIES="http://www.w3.org/2001/04/xmlenc#EncryptionProperties";
		//public final static String TYPE_ELEMENT="http://www.w3.org/2001/04/xmlenc#Element";
		public const System.String TYPE_CONTENT = "http://www.w3.org/2001/04/xmlenc#Content";
		
		// Optional (wird nicht benutzt)
		/// <summary> Kanonisierung (optional)
		/// </summary>
		public const System.String CANONICALIZATION = "http://www.w3.org/TR/2001/REC-xml-c14n-20010315";
		public const System.String EXC_CANONICALIZATION = "http://www.w3.org/2001/10/xml-exc-c14n#";
		
		// Transforms
		/// <summary> XSLT-Transformation
		/// </summary>
		public const System.String TRANSFORM_XSLT = "http://www.w3.org/TR/1999/REC-xslt-19991116";
		
		/// <summary> Kanonisierung
		/// </summary>
		public const System.String TRANSFORM_CANONICALIZATION = "http://www.w3.org/TR/2001/REC-xml-c14n-20010315";
		
		/// <summary> Tranformer fr Base64-Decoder
		/// </summary>
		public const System.String TRANSFORM_BASE64 = "http://www.w3.org/2000/09/xmldsig#base64";

		static Constants()
		{
			NET_MAP = new System.Collections.Hashtable();
			{
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA1, SIGNATURE_ALGORITHM_RSA_SHA1_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA256, SIGNATURE_ALGORITHM_RSA_SHA256_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA512, SIGNATURE_ALGORITHM_RSA_SHA512_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_RIPEMD160, SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_RIPEMD160_LEGACY, SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_ECDSA_SHA256, SIGNATURE_ALGORITHM_ECDSA_SHA256_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_ECDSA_SHA512, SIGNATURE_ALGORITHM_ECDSA_SHA512_NET);

                SupportClass.PutElement(OUT_DATES, DIGEST_ALGORITHM_SHA1, new DateTime(2008, 7, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_SHA1, new DateTime(2008, 7, 1));
                SupportClass.PutElement(OUT_DATES, DIGEST_ALGORITHM_RIPEMD160, new DateTime(2011, 1, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_RIPEMD160, new DateTime(2011, 1, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_RIPEMD160_LEGACY, new DateTime(2011, 1, 1));
            }
		}
	}
}