namespace de.osci.osci12.encryption {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.common;
	
	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class CipherData 
	{

		virtual public CipherReference CipherReference {
			get {
				return cipherReference;
			}
			set {
				if (this.cipherValue != null) {
					throw new de.osci.osci12.encryption.OSCICipherException("CipherValue Element wurde bereits eingestellt");
				}
				referenzedData = true;
				this.cipherReference = value;
			}
			
		}

		virtual public CipherValue CipherValue {
			get {
				return cipherValue;
			}
			
			set {
				if (this.cipherReference != null) {
					throw new de.osci.osci12.encryption.OSCICipherException("CipherReference Element wurde bereits eingestellt");
				}
				this.cipherValue = value;
			}
			
		}

		virtual public bool ReferenzedData {
			get {
				return referenzedData;
			}
			
		}

		private static Log log;
		private CipherReference cipherReference = null;
		private CipherValue cipherValue = null;
		private bool referenzedData = false;
		
		public CipherData() {
		}
		
		public CipherData(CipherValue cipherValue) {
			referenzedData = false;
			this.cipherValue = cipherValue;
		}
		
		public CipherData(CipherReference cipherRef) {
			referenzedData = true;
			this.cipherReference = cipherRef;
		}
		
		public virtual void  writeXML(System.IO.Stream out_Renamed, String ds, String xenc) {
			
			MoreSupport.ToStream(out_Renamed,"<" + xenc + ":CipherData>",Constants.CHAR_ENCODING);
			if (referenzedData) {
				cipherReference.writeXML(out_Renamed, ds, xenc);
			} else {
				cipherValue.writeXML(out_Renamed, xenc);
			}
			MoreSupport.ToStream(out_Renamed,"</" + xenc + ":CipherData>",Constants.CHAR_ENCODING);
		}

		static CipherData() {
			log = LogFactory.getLog(typeof(CipherData));
		}
	}
}