namespace de.osci.osci12.messagetypes {

	using System;
	using de.osci.osci12.messageparts;

	/// <summary> Dieses Interface wird von allen Nachrichtentypen implementiert, die
	/// Inhaltsdaten enthalten.
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public interface ContentPackageI {
		/// <summary>
		/// Liefert die Message-ID der Nachricht (Antwort). 
		/// </summary>
		/// <value>Message-ID 
		/// </value>
		String MessageId {get;}
		/// <summary>
		/// Liefert den im Antwortlaufzettel enthaltenen Betreff-Eintrag. 
		/// </summary>
		/// <value>Betreff der Antwortnachricht
		/// </value>
		String Subject {get;}
		/// <summary>
		/// Liefert die in die Nachricht eingestellten (unverschlsselten) Inhaltsdaten als ContentContainer-Objekte.
		/// </summary>
		/// <value>enthaltene ContentContainer mit Inhaltsdaten
		/// </value>
    		ContentContainer[] ContentContainer {
			get;	
		}
		/// <summary>
		/// Liefert die in die Nachricht eingestellten verschlsselten Inhaltsdaten 
		/// </summary>
		/// <value>enthaltene EncryptedData-Objekt mit verschlsselten Inhaltsdaten
		/// </value>
		EncryptedDataOSCI[] EncryptedData {
			get;
		}
	}
}