namespace de.osci.osci12.messagetypes {

	using System;
	using de.osci.osci12.common;
	using de.osci.osci12.messageparts;
	using de.osci.osci12.roles;
	using java.security;
 
	/// <summary>Diese Klasse dient dazu, von auerhalb des Packages auf Konstruktoren und
	/// Methoden zuzugreifen, die dort nicht sichtbar sind, um die API fr den Anwender
	/// bersichtlich zu halten. Die Klasse sollte deshalb nicht dokumentiert werden.
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	/// <seealso cref="ContentContainer"></seealso>
	/// <seealso cref="Attachment"></seealso>
	public class MessageTypesEntry {

		public MessageTypesEntry() {
			;
		}

		public static ResponseToInitDialog responseToInitDialog(InitDialog id) {
			return new ResponseToInitDialog(id);
		}

		public static ResponseToExitDialog responseToExitDialog(DialogHandler dH) {
			return new ResponseToExitDialog(dH);
		}

		public static ResponseToGetMessageId responseToGetMessageId(DialogHandler dH) {
			return new ResponseToGetMessageId(dH);
		}

		public static ResponseToStoreDelivery responseToStoreDelivery(DialogHandler dH) {
			return new ResponseToStoreDelivery(dH, false);
		}

		public static ResponseToFetchDelivery responseToFetchDelivery(FetchDelivery fd, StoreDelivery sd) {
			return new ResponseToFetchDelivery(fd, sd);
		}

		public static ResponseToFetchProcessCard responseToFetchProcessCard(FetchProcessCard fpc) {
			return new ResponseToFetchProcessCard(fpc);
		}

		public static ResponseToMediateDelivery responseToMediateDelivery(MediateDelivery md, ResponseToProcessDelivery rpd) {
			return new ResponseToMediateDelivery(md, rpd);
		}

		public static ResponseToForwardDelivery responseToForwardDelivery(AcceptDelivery ad, ResponseToAcceptDelivery rad) {
			return new ResponseToForwardDelivery(ad, rad);
		}

		public static ProcessDelivery processDelivery(MediateDelivery md) {
			return new ProcessDelivery(md);
		}

		public static AcceptDelivery acceptDelivery(ForwardDelivery fd) {
			return new AcceptDelivery(fd);
		}

		public static void setFeedBack(OSCIResponseTo rsp, String[] codes) {
			rsp.setFeedback(codes);
		}

		public static void sign(OSCIMessage msg) {
			if (msg is OSCIRequest)
				((OSCIRequest)msg).sign();
			else
				((OSCIResponseTo)msg).sign();
		}

		public static void writeXML(OSCIMessage rsp, System.IO.Stream out0) {
			rsp.writeXML(out0);
		}
		public static void addContentContainer(OSCIMessage msg, ContentContainer coco)  {
			msg.addContentContainer(coco);
		}
	}
}
