namespace de.osci.osci12.messagetypes {

	using System;
	using org.xml.sax;
	using de.osci.osci12.common;
	using de.osci.osci12.dotcommon;

	/// <summary> Die Klasse ist der Einrittspunkt fr Nachrichten, die bei einem passiven Empfnger
	/// eingehen.
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class PassiveRecipientParser:de.osci.osci12.messagetypes.IncomingMSGParser {

		internal override OSCIEnvelopeBuilder getParser(XMLReader reader, DialogHandler dh) {
			return new OSCIEnvelopeBuilder(reader, dh);
		}
		
		/// <summary> Diese Methode parst eine Nachricht, die ber einen InputStream eingeht.
		/// Sie wird in der Regel von einem Servlet (o..) aufgerufen.
		/// </summary>
		/// <param name="input">InputStream der eingehenden Daten.
		/// </param>
		/// <returns> die eingelesene OSCI-Auftragsnachricht (Annahme- oder Bearbeitungsauftrag).
		/// </returns>
		public virtual OSCIRequest parseStream(System.IO.Stream input) 
		{
			defaultSupplier = DialogHandler.DefaultSuppliers;
			return (OSCIRequest) base.parseStream(input, null, true, null);
		}
		
		/// <summary> Diese Methode baut eine SOAP-Fehlermeldung auf Nachrichtenebene auf.
		/// </summary>
		/// <param name="code"> OSCI-Code des Fehlers
		/// </param>
		/// <returns> SOAP-Nachricht
		/// </returns>
		public static System.String createSoapError(System.String code) {
			return "SOAP-Error";
		}
	}
}