namespace de.osci.osci12.roles {

	using System;
	using de.osci.osci12;

	/// <summary> Diese Exception zeigt an, dass einem Rollenobjekt fr eine unzulssige Operation
	/// verwendet wurde. <p>Beispiel: An die Methode ContentContainer.sign(Role) wird ein
	/// Role-Objekt bergeben, welches kein Signer-Objekt enthlt.</p>
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class OSCIRoleException:OSCIException {
		
		public OSCIRoleException(System.String message):base(message) {
		}
		
		public OSCIRoleException(System.String message, System.String errorCode):base(message, errorCode) {
		}
	}
}