namespace de.osci.osci12.signature {

	using System;
	using org.apache.commons.logging;
	
	/// <exclude/>
	/// <summary> Element xdsig:RetrievalMethod.
	/// 
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: PPI Financial Systems GmbH</p> 
	/// </summary>
	public class RetrievalMethod 
	{
		private void  InitBlock() {
			transformer = new System.Collections.ArrayList();
		}

		virtual public System.String[] Transformers {
			get {
				return (System.String[]) transformer.ToArray(typeof(String));
			}
			
		}
		
		/// <summary> Ruft den Wert des Attributs URI ab, oder legt diesen fest.
		/// Dieses Attribut ist REQUIRED.
		/// </summary>
		/// <value> URI.
		/// <p>@roseuid 3AA8FC2D0159; 3AA8FC2D0157</p>
		/// </value>
		virtual public System.String URI {
			get {
				return uri;
			}
			
			set {
				this.uri = value;
			}
			
		}

		/// <summary> Ruft den Wert des Attributs xdsig:Type ab.
		/// </summary>
		/// <value> String.
		/// </value>
		virtual public System.String Type {
			get {
				return TYPE;
			}
			
		}

		protected internal static Log log;
		
		/// <summary> Wert des Attributs xdsig:Type.
		/// </summary>
		private System.String TYPE = "http://www.w3.org/2000/09/xmldsig#X509Data";
		
		/// <summary> Wert des Attributs xdsig:URI.
		/// </summary>
		private System.String uri;

		private System.Collections.ArrayList transformer;
		
		/// <summary> Standard-Konstruktor.
		/// </summary>
		public RetrievalMethod() {
			InitBlock();
		}
		
		public virtual void  addTransformer(System.String transformer) {
			
		}
		
		static RetrievalMethod() {
			log = LogFactory.getLog(typeof(RetrievalMethod));
		}
	}
}