namespace de.osci.osci12.soapheader {
	using System;
	using org.apache.commons.logging;
	using org.xml.sax;
	using de.osci.osci12.messageparts;
	using de.osci.osci12.messagetypes;

	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class DesiredLanguagesHBuilder:de.osci.osci12.messageparts.MessagePartParser 
	{

		private void  InitBlock() {
			log = LogFactory.getLog(typeof(DesiredLanguagesHBuilder));
		}

		internal DesiredLanguagesH dlh;
		new private Log log;
		
		/// <summary> Constructor for the DesiredLanguagesHBuilder object
		/// </summary>
		/// <param name="xmlReader">
		/// </param>
		/// <param name="parentHandler">
		/// </param>
		/// <param name="atts">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public DesiredLanguagesHBuilder(OSCIMessageBuilder parent, Attributes atts):base(parent) {
			InitBlock();
			if (atts.getValue("LanguagesList") == null) {
				throw new org.xml.sax.SAXException("Keine Sprachliste im DesiredLanguage-Header !");
			}
			dlh = new DesiredLanguagesH(atts.getValue("LanguagesList"));
			parent.OSCIMessage.desiredLanguagesH = dlh;
		}
		
		/// <summary> 
		/// </summary>
		/// <param name="uri">
		/// </param>
		/// <param name="localName">
		/// </param>
		/// <param name="qName">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public override void  endElement(System.String uri, System.String localName, System.String qName) {
			log.debug("End-Element: " + qName);
			if (localName.Equals("DesiredLanguages")&& uri.Equals(OSCI_XMLNS)) {
				msg.desiredLanguagesH = dlh;
				xmlReader.setContentHandler(parentHandler);
			}
			else {
				throw new org.xml.sax.SAXException("Unbekanntes Element gefunden: " + qName);
			}
		}
	}
}