namespace de.osci.osci12.soapheader {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.common;

	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class OsciH:HeaderEntry 
	{

		/// <summary>  Gets the refID attribute of the OsciH object
		/// </summary>
		/// <value>  The refID value
		/// </value>
		override public System.String RefID {
			get {
				return name.ToLower();
			}	
		}

		new private static Log log;
		internal System.String name, data;
		
		public OsciH(System.String name, System.String data) {
			this.name = name;
			this.data = data;
		}
		
		/// <summary>
		/// </summary>
		/// <param name="out_Renamed">
		/// </param>
		/// <exception cref="System.Exception"> IOException
		/// </exception>
		public override void  writeXML(System.IO.Stream out_Renamed) {
			if (tmpBuffer != null) {
				out_Renamed.Write(tmpBuffer,0,tmpBuffer.Length);
			} else {
				log.debug("RefID: " + RefID);
    MoreSupport.ToStream(out_Renamed,"<" + osciNSPrefix + ":" + name,Constants.CHAR_ENCODING);
    out_Renamed.Write(ns,0,ns.Length);
    MoreSupport.ToStream(out_Renamed," Id=\"" + RefID +
              "\" " + soapNSPrefix + ":actor=\"http://schemas.xmlsoap.org/soap/actor/next\" " + soapNSPrefix + ":mustUnderstand=\"1\">",Constants.CHAR_ENCODING);
				MoreSupport.ToStream(out_Renamed,data,Constants.CHAR_ENCODING);
				MoreSupport.ToStream(out_Renamed,"</" + osciNSPrefix + ":" + name + ">",Constants.CHAR_ENCODING);
			}
		}
		static OsciH() {
			log = LogFactory.getLog(typeof(OsciH));
		}
	}
}