namespace de.osci.osci12.soapheader {

	using System;
	using org.apache.commons.logging;
	 
	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class QualityOfTimestampH:HeaderEntry 
	{

		virtual public bool QualityCryptographic {
			get {
				return quality;
			}
		}

		virtual public bool ServiceReception {
			get {
				return service;
			}	
		}

		new private static Log log;
		private bool service;
		private bool quality;
		
		public QualityOfTimestampH(bool serviceReception, bool qualityCryptographic) {
			this.service = serviceReception;
			this.quality = qualityCryptographic;
			id = "qualityoftimestamp_" + (service ? "reception" : "creation");
		}
		
		public override void  writeXML(System.IO.Stream out_Renamed) {
			if (tmpBuffer != null) {
				byte[] temp_byteArray;
				temp_byteArray = tmpBuffer;
				out_Renamed.Write(temp_byteArray, 0, temp_byteArray.Length);;;;
			}
			else {
   MoreSupport.ToStream(out_Renamed,"<" + osciNSPrefix + ":QualityOfTimestamp",de.osci.osci12.common.Constants.CHAR_ENCODING);
   out_Renamed.Write(ns,0,ns.Length);
   MoreSupport.ToStream(out_Renamed," Id=\"" + RefID + "\" Quality=\"" +
               (quality ? "cryptographic" : "plain") + "\" Service=\"" +
               (service ? "reception" : "creation") +
               "\" "+ soapNSPrefix + ":actor=\"http://schemas.xmlsoap.org/soap/actor/next\" " + soapNSPrefix + ":mustUnderstand=\"1\"" +
               "></" + osciNSPrefix + ":QualityOfTimestamp>",de.osci.osci12.common.Constants.CHAR_ENCODING);
			}
		}
		static QualityOfTimestampH() {
			log = LogFactory.getLog(typeof(QualityOfTimestampH));
		}
	}
}