namespace de.osci.osci12.soapheader {

	using System;
	using org.apache.commons.logging;
	using org.xml.sax;
	using de.osci.osci12.messageparts;
	using de.osci.osci12.messagetypes;

	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2011 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von bremen online services Entwicklungs- und
	/// Betriebsgesellschaft GmbH &amp; Co. KG</p>
	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
	/// Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
	/// 28015 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.5</p>
	/// </summary>
	public class QualityOfTimestampHBuilder:de.osci.osci12.messageparts.MessagePartParser 
	{

		/// <summary> Gets the qualityOfTimestampH attribute of the QualityOfTimestampHBuilder
		/// object
		/// </summary>
		/// <value>The qualityOfTimestampH value
		/// </value>
		virtual public QualityOfTimestampH QualityOfTimestampH {
			get {
				return quotsh;
			}
			
		}

		new private static Log log;
		internal QualityOfTimestampH quotsh;
		
		/// <summary> Constructor for the QualityOfTimestampHBuilder object
		/// </summary>
		/// <param name="parentHandler">
		/// </param>
		/// <param name="atts">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public QualityOfTimestampHBuilder(OSCIMessageBuilder parentHandler, Attributes atts):base(parentHandler) {
			quotsh = new QualityOfTimestampH(atts.getValue("Service").Equals("reception"), atts.getValue("Quality").Equals("cryptographic"));
			if (quotsh.ServiceReception) {
				parentHandler.OSCIMessage.qualityOfTimestampTypeReception = quotsh;
			}
			else {
				parentHandler.OSCIMessage.qualityOfTimestampTypeCreation = quotsh;
			}
			if (atts.getValue("Id") != null) quotsh.RefID=atts.getValue("Id");
			OSCIMessage msg = parentHandler.OSCIMessage; 
			quotsh.setNSPrefixes(msg); 

		}
		
		/// <summary>
		/// </summary>
		/// <param name="uri">
		/// </param>
		/// <param name="localName">
		/// </param>
		/// <param name="qName">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public override void  endElement(System.String uri, System.String localName, System.String qName) {
			if (!(localName.Equals("QualityOfTimestamp") && uri.Equals(OSCI_XMLNS))) {
				throw new org.xml.sax.SAXException("Unbekanntes Element gefunden: " + localName);
			}
			xmlReader.setContentHandler(parentHandler);
		}
		static QualityOfTimestampHBuilder() {
			log = LogFactory.getLog(typeof(QualityOfTimestampHBuilder));
		}
	}
}