namespace de.osci.osci12.messageparts {
 
using System;
using System.Text;

	/// <summary>
	/// Zusammenfassung fr ISO8601DateTimeFormat.
	/// </summary>
	public class ISO8601DateTimeFormat
	{
		public String format(DateTime date) {
			StringBuilder sb= format(date, new StringBuilder(),null);
			return sb.ToString();
		}
		private StringBuilder format(DateTime date, StringBuilder sbuf, Int32[] fieldPosition)
		{
			DateTime utcdt = date.ToUniversalTime();
			sbuf.Append(date.ToString(System.Globalization.CultureInfo.InvariantCulture.DateTimeFormat.SortableDateTimePattern));
			TimeSpan ts=((TimeSpan)(date-utcdt));
			sbuf.Append(ts.Hours<0?"-":"+");
			sbuf.Append(Math.Abs(ts.Hours)>9?"":"0");
			sbuf.Append(ts.Hours+":");
			sbuf.Append(Math.Abs(ts.Minutes)>9?"":"0");
			sbuf.Append(ts.Minutes);
			return sbuf;
		}
		public DateTime parse(string s){
			return DateTime.Parse(s);
		}
		public System.Globalization.DateTimeFormatInfo MakeFormat(){
			return new System.Globalization.DateTimeFormatInfo();
		}
	}
}
