namespace java.security.cert {

	using System;
	using System.Text;
    using Org.BouncyCastle.X509;


	/// <summary>
	/// Zusammenfassung fr X509Certificate.
	/// </summary>
	public class X509Certificate:Org.BouncyCastle.X509.X509Certificate
	{
		private IssuerDN mIssuerDN;

        public X509Certificate(byte[] data)
            : base(Org.BouncyCastle.Asn1.X509.X509CertificateStructure.GetInstance(new Org.BouncyCastle.Asn1.Asn1InputStream(data).ReadObject()))
        {
            mIssuerDN = new IssuerDN(base.IssuerDN.ToString());
        }

        public X509Certificate(System.IO.Stream data)
            : base(Org.BouncyCastle.Asn1.X509.X509CertificateStructure.GetInstance(new Org.BouncyCastle.Asn1.Asn1InputStream(data).ReadObject()))
        {
            mIssuerDN = new IssuerDN(base.IssuerDN.ToString());
            data.Close();
        }

        public byte[] GetRawCertData()
        {
            return GetEncoded();
        }

        // Testen
        public String GetIssuerName()
        {
            return mIssuerDN.Name();
        }

        // Testen
        public String GetSerialNumber()
        {
            return SerialNumber.ToString();
        }

        // Testen   
        public IssuerDN IssuerDN()
        {
            return mIssuerDN;
		}
 

		public byte[] getEncoded() 
        {
			return base.GetEncoded();
		}
 
//Testen

		public string GetName() 
		{
            return SubjectDN.ToString();
		}

	
	} // class

    public class IssuerDN
    {
        private String name;

        public IssuerDN(String name)
        {
            this.name = name;
        }

        public String toString()
        {
            throw new InvalidOperationException("Nicht implementiert");
        }

        public String Name()
        {
            return name;
        }
    } // class

} // namespace
